#include "interface-gui-menu.h"

GtkWidget *gui_menu_make_file();
GtkWidget *gui_menu_make_move();
GtkWidget *gui_menu_make_fractal();
GtkWidget *gui_menu_make_help();

GtkWidget *gui_menu_menubar() {
	GtkWidget	*mniFile,
			*mniMove,
			*mniFractal,
			*mniHelp;
	GtkWidget	*mnFile,
			*mnMove,
			*mnFractal,
			*mnHelp;

	GtkWidget *menuBar;
	
	menuBar = gtk_menu_bar_new();

	mniFile = gtk_menu_item_new_with_mnemonic("_File");
		mnFile = gui_menu_make_file();
	mniMove = gtk_menu_item_new_with_mnemonic("Ac_tion");
		mnMove = gui_menu_make_move();
	mniFractal = gtk_menu_item_new_with_mnemonic("Fra_ctal");
		mnFractal = gui_menu_make_fractal();
	mniHelp = gtk_menu_item_new_with_mnemonic("_Help");
		mnHelp = gui_menu_make_help();
	
	gtk_menu_shell_append((GtkMenuShell*)menuBar, mniFile);
		gtk_menu_item_set_submenu((GtkMenuItem*)mniFile, mnFile);
	gtk_menu_shell_append((GtkMenuShell*)menuBar, mniMove);
		gtk_menu_item_set_submenu((GtkMenuItem*)mniMove, mnMove);
	gtk_menu_shell_append((GtkMenuShell*)menuBar, mniFractal);
		gtk_menu_item_set_submenu((GtkMenuItem*)mniFractal, mnFractal);
	gtk_menu_shell_append((GtkMenuShell*)menuBar, mniHelp);
		gtk_menu_item_set_submenu((GtkMenuItem*)mniHelp, mnHelp);
	
	return menuBar;
}

GtkWidget *gui_menu_make_file() {
	GtkWidget	*mniFileSaveimage,
			*mniFileSeparator1,
			*mniFileSavesettings,
			*mniFileLoadsettings,
			*mniFileSeparator2,
			*mniFileQuit;

	GtkWidget	*mnFile;
	GtkWidget	*imgQuit;
	GtkWidget	*imgSaveIm;
	GtkWidget	*imgOptSav;
	GtkWidget	*imgOptLoa;
	
	mnFile = gtk_menu_new();
	imgSaveIm = gtk_image_new_from_file ("imgs/image.png");

	mniFileSaveimage = gtk_image_menu_item_new_with_mnemonic("Save _Image...");
	  {gtk_widget_add_accelerator(
		mniFileSaveimage,
		"activate",
		accelGroup,
		gdk_keyval_from_name("S"),
		GDK_CONTROL_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniFileSaveimage,imgSaveIm);}

	mniFileSeparator1 = gtk_separator_menu_item_new();
	imgOptSav = gtk_image_new_from_file ("imgs/ssave.png");
	mniFileSavesettings = gtk_image_menu_item_new_with_mnemonic("_Save Settings...");
	  {gtk_widget_add_accelerator(
		mniFileSavesettings,
		"activate",
		accelGroup,
		gdk_keyval_from_name("E"),
		GDK_CONTROL_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniFileSavesettings,imgOptSav);}
	imgOptLoa = gtk_image_new_from_file ("imgs/sload.png");

	mniFileLoadsettings = gtk_image_menu_item_new_with_mnemonic("_Load Settings...");
	  {gtk_widget_add_accelerator(
		mniFileLoadsettings,
		"activate",
		accelGroup,
		gdk_keyval_from_name("L"),
		GDK_CONTROL_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	 {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniFileLoadsettings,imgOptLoa);}
	
	imgQuit = gtk_image_new_from_file ("imgs/quit.png");
	mniFileSeparator2 = gtk_separator_menu_item_new();
	mniFileQuit = gtk_image_menu_item_new_with_mnemonic("_Quit");
	  {gtk_widget_add_accelerator(
		mniFileQuit,
		"activate",
		accelGroup,
		gdk_keyval_from_name("Q"),
		GDK_CONTROL_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniFileQuit,imgQuit);}



	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileSaveimage);
	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileSeparator1);
	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileSavesettings);
	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileLoadsettings);
	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileSeparator2);
	gtk_menu_shell_append((GtkMenuShell*)mnFile, mniFileQuit);

	g_signal_connect((GObject*)mniFileSaveimage, "activate", (GCallback)saveImage_ev, NULL);
	g_signal_connect((GObject*)mniFileSavesettings, "activate", (GCallback)saveSettings_ev, NULL);
	g_signal_connect((GObject*)mniFileLoadsettings, "activate", (GCallback)loadSettings_ev, NULL);
	g_signal_connect((GObject*)mniFileQuit, "activate", (GCallback)destroy_ev, NULL);

	return mnFile;
}

GtkWidget *gui_menu_make_fractal() {
	GtkWidget	*mniFractalSeparator,
			*mniFractalReset;

	GtkWidget	*mnFractal;
	GtkWidget	*imgReset;
	GSList	*group;
	
	int i;
	
	group = NULL;
	
	mnFractal = gtk_menu_new();
	imgReset = gtk_image_new_from_file ("imgs/reset.png");

	for (i = 0; i < FRACTALS; i++) {
		mniFractalItem[i] = gtk_radio_menu_item_new_with_label(group,frac_name(i+1));
		group = gtk_radio_menu_item_get_group(GTK_RADIO_MENU_ITEM(mniFractalItem[i]));
	}
	mniFractalSeparator = gtk_separator_menu_item_new();
	mniFractalColor = gtk_check_menu_item_new_with_mnemonic("_Color");
	  {gtk_widget_add_accelerator(
	  	mniFractalColor,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("M"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	mniFractalReset = gtk_image_menu_item_new_with_mnemonic("_Reset All");
	  {gtk_widget_add_accelerator(
	  	mniFractalReset,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("R"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniFractalReset,imgReset);}

	for (i = 0; i < FRACTALS; i++)
		gtk_menu_shell_append((GtkMenuShell*)mnFractal, mniFractalItem[i]);
	gtk_menu_shell_append((GtkMenuShell*)mnFractal, mniFractalSeparator);
	gtk_menu_shell_append((GtkMenuShell*)mnFractal, mniFractalColor);
	gtk_menu_shell_append((GtkMenuShell*)mnFractal, mniFractalReset);

	for (i = 0; i < FRACTALS; i++)
		g_signal_connect((GObject*)mniFractalItem[i], "toggled", (GCallback)change_fractal_ev, NULL);
	g_signal_connect((GObject*)mniFractalColor, "toggled", (GCallback)color_from_menu_ev, NULL);
	g_signal_connect((GObject*)mniFractalReset, "activate", (GCallback)reset_ev, NULL);

	return mnFractal;
}

GtkWidget *gui_menu_make_move() {
	GtkWidget	*mniMoveUp,
			*mniMoveDown,
			*mniMoveLeft,
			*mniMoveRight,
			*mniMoveZoomin,
			*mniMoveZoomout;
	GtkWidget	*imgLeft,
			*imgRight,
			*imgUp,
			*imgDown,
			*imgOut,
			*imgIn;
			
	GtkWidget	*mnMove;
	
	mnMove = gtk_menu_new();
	imgLeft = gtk_image_new_from_file ("imgs/left.png");
	imgRight = gtk_image_new_from_file ("imgs/right.png");
	imgUp = gtk_image_new_from_file ("imgs/up.png");
	imgDown = gtk_image_new_from_file ("imgs/down.png");
	imgOut = gtk_image_new_from_file ("imgs/minus.png");
	imgIn = gtk_image_new_from_file ("imgs/plus.png");

	mniMoveUp = gtk_image_menu_item_new_with_mnemonic("Move _Up");
	  {gtk_widget_add_accelerator(
	  	mniMoveUp,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("I"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveUp,imgUp);}
	mniMoveDown = gtk_image_menu_item_new_with_mnemonic("Move _Down");
	  {gtk_widget_add_accelerator(
	  	mniMoveDown,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("K"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveDown,imgDown);}
	mniMoveLeft = gtk_image_menu_item_new_with_mnemonic("Move _Left");
	  {gtk_widget_add_accelerator(
	  	mniMoveLeft,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("J"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveLeft,imgLeft);}
	mniMoveRight = gtk_image_menu_item_new_with_mnemonic("Move _Right");
	  {gtk_widget_add_accelerator(
	  	mniMoveRight,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("L"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveRight,imgRight);}
	mniMoveZoomin = gtk_image_menu_item_new_with_mnemonic("Zoom _In");
	  {gtk_widget_add_accelerator(
	  	mniMoveZoomin,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("O"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveZoomin,imgIn);}
	mniMoveZoomout = gtk_image_menu_item_new_with_mnemonic("Zoom _Out");
	  {gtk_widget_add_accelerator(
	  	mniMoveZoomout,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("U"),
		GDK_SHIFT_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	  {gtk_image_menu_item_set_image((GtkImageMenuItem*)mniMoveZoomout,imgOut);}


	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveUp);
	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveDown);
	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveLeft);
	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveRight);
	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveZoomin);
	gtk_menu_shell_append((GtkMenuShell*)mnMove, mniMoveZoomout);

	g_signal_connect((GObject*)mniMoveUp, "activate", (GCallback)moveUp_ev, NULL);
	g_signal_connect((GObject*)mniMoveDown, "activate", (GCallback)moveDown_ev, NULL);
	g_signal_connect((GObject*)mniMoveLeft, "activate", (GCallback)moveLeft_ev, NULL);
	g_signal_connect((GObject*)mniMoveRight, "activate", (GCallback)moveRight_ev, NULL);
	g_signal_connect((GObject*)mniMoveZoomin, "activate", (GCallback)moveZoomIn_ev, NULL);
	g_signal_connect((GObject*)mniMoveZoomout, "activate", (GCallback)moveZoomOut_ev, NULL);

	return mnMove;
}

GtkWidget *gui_menu_make_help() {
	GtkWidget	*mniHelpAbout;
	GtkWidget	*mnHelp;
	GtkWidget	*imgHelp;

	mnHelp = gtk_menu_new();
	imgHelp = gtk_image_new_from_file ("imgs/about.png");

	mniHelpAbout = gtk_image_menu_item_new_with_mnemonic("_About");
	  {gtk_widget_add_accelerator(
	  	mniHelpAbout,
	  	"activate",
	  	accelGroup,
	  	gdk_keyval_from_name("A"),
		GDK_CONTROL_MASK,
		GTK_ACCEL_VISIBLE
	  );}
	{gtk_image_menu_item_set_image((GtkImageMenuItem*)mniHelpAbout,imgHelp);}


	gtk_menu_shell_append((GtkMenuShell*)mnHelp, mniHelpAbout);

	g_signal_connect((GObject*)mniHelpAbout, "activate", (GCallback)about_ev, NULL);

	return mnHelp;
}
